function res=statis(col0);

// distributed under the CeCILL-C license
// copyright INRA-IRSTEA 2013

// get Scilab version
sci_version=strtod(part(getversion(),[8 ;9 ;10]));
if sci_version < 6 then
      accolade1='(';
      accolade2=')';
else 
      accolade1='{';
      accolade2='}';
end
if sci_version < 6 then
    stacksize('max');
end

[test0,col]=islist(col0);

WK=cell();
ntable=size(col);
for i=1:ntable;
chaine=('t'+ string(i)+ '             ');
table_name(i)=part(chaine,1:10);
end

obs_name=col(1).i;// the identifiers of the first table taken as observation name
// centring the tables and assessement of the Wk matrices
for(i=1:ntable)
x=col(i).d;
[nrow ncol]=size(x);
ave=mean(x,1);
//X=(1/nrow)*(x-ones(nrow,1)*ave);
X=(x-ones(nrow,1)*ave);
//norm(X,'fro')
//X=x-ones(nrow,1)*ave;
Wk=X*X';
Wk=Wk/norm(Wk,'fro');//// normed objects !!!

//=============

aux(i,:)=matrix(Wk,1,nrow*nrow);
execstr(msprintf('WK%s i %s.entries.d=Wk;',accolade1,accolade2))
execstr(msprintf('WK%s i %s.entries.v=col(i).i;',accolade1,accolade2))
aux1=(string(i)+ '     ');
aux1=part(aux1,(1:3));

aux1=char(ones(nrow,1)*ascii(aux1));

execstr(msprintf('WK%s i %s.entries.i=(aux1 + col(i).i);',accolade1,accolade2))
execstr(msprintf('WK%s i %s.entries=div(WK%s i %s.entries);' , accolade1,accolade2,accolade1,accolade2))

end;
RV=aux*aux';
res.RV.d=RV;
res.RV.i=table_name;
res.RV.v=table_name;
res.RV=div(res.RV);

[V,D] = statis_eigs(RV,1);
D=abs(D);
V=abs(V);
res.eigenval1.d=D;
res.eigenval1.i='First eigenvalue of RV';
res.eigenval1.v='First eigenvalue of RV';
res.eigenval1=div(res.eigenval1);

res.eigenvec1.d=V;
res.eigenvec1.i=table_name;
res.eigenvec1.v='First eigenvector of RV';
res.eigenvec1=div(res.eigenvec1);

res.Wk=WK;
// assessment of the W compromise
//V=V*sqrt(D(1));
execstr(msprintf('aux=WK%s 1 %s.entries;',accolade1,accolade2))
aux=aux.d;
W=V(1)*aux;
//size(W)
for i=2:ntable
execstr(msprintf('aux=WK%s i %s.entries.d;',accolade1,accolade2))
W=W+V(i)*aux;
end
W=W/ntable;
res.W_compromise.d=W;
res.W_compromise.i=obs_name;
res.W_compromise.v=obs_name;
res.W_compromise=div(res.W_compromise);

// scores of the tables
r=rank(W);
[V1,D1] = statis_eigs(W,r);
res.eigenval2.d=diag(D1);
res.eigenval2.v='eigenvalues of W compromise';
res.eigenval2.i=string((1:r)');

res.eigenval2=div(res.eigenval2);

res.eigenvec2.d=V1;
res.eigenvec2.i=obs_name;
res.eigenvec2.v=res.eigenval2.i;
res.eigenvec2=div(res.eigenvec2);

res.score.d=W*V1/sqrt(D1);
res.score.i=obs_name;
res.score.v=res.eigenval2.i;
res.score=div(res.score);

//assessment of the trajectory of the observation according to the tables
t.d=[];
t.i=[];
g.d=[];
for i=1:ntable
execstr(msprintf('aux=WK%s i %s.entries.d;',accolade1,accolade2))
aux1=V(i)*aux;r
t.d=[t.d;aux1];
execstr(msprintf('t.i=[t.i;WK%s i %s.entries.i];',accolade1,accolade2))
g.d=[g.d; (1:nrow)'];
end
t.d=t.d*V1/sqrt(D1);
t.v=res.eigenval2.i;

res.trajectory=t;
res.trajectory=div(res.trajectory);

g.i=t.i;
g.v='Rank of the observation';

res.xgroup=g;
res.xgroup=div(res.xgroup);

// assessing the factorial map of tables
[V,D]=spec(RV);
[D,index]=gsort(-diag(D)','g','i');
D=-D;
V=V(:,index);
res.table_score.d=V*sqrt(diag(D));
res.table_score.i=table_name;
aux1=D/sum(D)*100;
clear aux;
for i=1:ntable
aux(i).entries=xdisp('score # ',i ,' ',round(aux1(i)*10)/10,'%');
end

res.table_score.v=aux(1).entries;
for i=2:size(aux,1);
    res.table_score.v=[res.table_score.v; aux(1).entries];
end

res.table_score=div(res.table_score);

res.table_eigenval.d=D';
res.table_eigenval.v='eigenvalues of RV';
res.table_eigenval.i=res.table_score.v;

res.table_eigenval=div(res.table_eigenval);
endfunction

//============================================================


// subfunction: statis_eigs ==================================


function [eigenvec,eigenval]=statis_eigs(X,n)
//eigs     - eigenvectors and eigenvalues of a square matrix  
//function [eigenvec,eigenval]=eigs(X,n)
//X: SCILAB matrix 
//n: number of asked eigenvalues an eigenvectors
//Crude simulation of function "eigs" from matlab  

[v,d]=spec(X);//
//'sort'
[eigenval, index]=gsort(abs(diag(d)));// eigenvalues in increasing order!
eigenval=diag(eigenval(1:n));
eigenvec=v(:,index(1:n)); 

endfunction 



